use std::{ops::Deref, path::PathBuf, sync::{Arc, RwLock}, time::Duration};

use clap::Parser;

use brute_forcer::Bruter;

use crate::discord_invite::DiscordInviteError;
pub mod discord_invite;
pub mod brute_forcer;
pub mod tui;

#[derive(Parser, Debug, Clone)]
pub struct Args{
    wordlist: PathBuf,
    #[clap(default_value_t = 10)]
    iterations: usize,
}

fn main() -> anyhow::Result<()>{
    let args = Args::parse();
    let mut bruter = Bruter::new(args.iterations);
    let b_ref = bruter.clone();
    let mut codes = vec![];
    for w in std::fs::read_to_string(args.wordlist).unwrap().split('\n'){
        codes.push(w.to_string());
    }
    bruter.set_codes(codes);
    Bruter::start(bruter).unwrap();
    Ok(())
}